#LibPath "lib"

#Define GAME_DEBUG

#Ifdef GAME_DEBUG
	#Define GDPrint(Msg)  Open cons For Output As #99:Print #99, Msg:Close #99
#Else
	#Define GDPrint(Msg):
#EndIf

#Include "fbgfx.bi"
#Include "sound.bas"
#Include "static.bi"
#Include "font.bi"
#Include "fps.bi"
#Include "gamedata.bi"
#Include "starfield.bi"
#Include "hotspot.bi"

#Define SCRW   800  
#Define SCRH   600

#Define MAX_HOTSPOT_INDEX 3

Using fb

Declare Sub HotCallback(hotspot As _hotspot Ptr, args As _MEVENTARGS)

Sub ProcessKeys(GameState As _GameData)
   
   'Help
   If KeyPress(SC_F12) Or (GameState.MouseFunction = 1) Then
      GameState.HlpTimer = Timer      
   EndIf
        
   'Insert Coin 
   If KeyPress(SC_F1) Or (GameState.MouseFunction = 2) Then
      SoundEffect(GameState.Sounds.Clip(Coin))
      GameState.Coins += 1
      GameState.Spent += 1
   EndIf
      
         
   If GameState.flagRollDone Then
   
      'Bet 1
      If KeyPress(SC_F2) Or (GameState.MouseFunction = 3) Then
         If GameState.Bet < 3 AndAlso GameState.Coins > 0 Then
            GameState.Bet += 1
            GameState.Coins -= 1
            GameState.LastBet = GameState.Bet
            SoundEffect(GameState.Sounds.Clip(Coin))
         End If
      EndIf   
   
      ' Bet Max
      If (KeyPress(SC_F3) Or (GameState.MouseFunction = 4)) AndAlso GameState.Coins > 2 Then
         If GameState.Bet < 3 Then
            Dim amt As Integer = 3 - GameState.Bet 
            GameState.Bet += amt 
            GameState.Coins -= amt
            GameState.LastBet = GameState.Bet
            SoundEffect(GameState.Sounds.Clip(Coin))
         End If
       EndIf
       
      ' Spin
      If KeyPress(SC_F4) Or (GameState.MouseFunction = 5)Then
         If (GameState.flagStopTheRest = 1) Then
            GameState.flagSpinClicked = 1
            GDPrint("GameState.flagSpinClicked = 1")
         Else
            GameState.StarRolls()
         EndIf
      EndIf
   
   Else
      
      ' Stop The Rest
      If KeyPress(SC_F4) Or (GameState.MouseFunction = 5)Then
         If (GameState.flagStopTheRest = 1) Then
            GameState.flagSpinClicked = 1
            GDPrint("GameState.flagSpinClicked = 1")
         EndIf
      EndIf    
      
   End If  
         
   GameState.MouseFunction = 0
            
End Sub


Sub Main()
   
   ScreenRes SCRW,SCRH,32,,GFX_ALWAYS_ON_TOP
   WindowTitle("BTN Slots")
   
   Dim As _GameData GameState
   Dim As _starfield          Stars = _starfield(200,SCRW,SCRH)
   Dim As _fps                FPS   = 60
   Dim As _hotspot Ptr hotspot 
   
   Dim As Integer mx,my,buttons,wheel,clip, lastbtn
   Dim As Double stime,etime   
        
      hotspot = New _hotspot[MAX_HOTSPOT_INDEX+1] 
      hotspot[0].Initialize(0,148,425,44,30, @HotCallBack)
      hotspot[1].Initialize(1,290,425,44,30, @HotCallBack)
      hotspot[2].Initialize(2,432,425,44,30, @HotCallBack)
      hotspot[3].Initialize(3,572,425,44,30, @hotcallback)
              
      InitSound()
      LoadSounds(GameState.Sounds)
         
      Stars.SetStars(1.2,10)
      
      GameState.AddMessage("BTN Slots!")
      GameState.AddMessage("By Vincent DeCampo")
      GameState.AddMessage("for 2014 FreeBASIC Game Competition")
      
      Do      
         
         'Test if time for next frame
         If FPS.IsTime() Then                
            
           'Render
            ScreenLock
            
               Cls
               Stars.DrawMe(0)
               GameState.DrawMe(0)
               GameState.DrawRolls(0)
               GameState.DrawLiteBars(0)
               GameState.DrawTopLine(0)
               GameState.DrawHelp(0)
               
            ScreenUnLock
            
            GameState.ProcessRolls()
            
            SustainSound(GameState.Sounds.Clip(Casino))
         
            GameState.jackpot += 1
                           
         Else 
            
            Sleep 1
                   
         EndIf     
         
         'Process Hotspots
         For i As Integer=0 To MAX_HOTSPOT_INDEX
            hotspot[i].Process(@GameState)
         Next
               
         ProcessKeys(GameState)
               
      Loop Until KeyPress(SC_ESCAPE) 

End Sub

Sub HotCallBack(hotspot As _hotspot Ptr, args As _MEVENTARGS)
Dim As _GameData Ptr GameState = args.object

   Select Case hotspot->_idx
      Case 0 : GameState->MouseFunction = 2
      Case 1 : GameState->MouseFunction = 3
      Case 2 : GameState->MouseFunction = 4
      Case 3 : GameState->MouseFunction = 5
         
         
   End Select
 
End Sub


Main()
