#Include "vbcompat.bi"

Type _GameData
       
   Const MAX_ROLLS   = 5
   Const ROLL_HEIGHT = 935
   Const ROLL_WIDTH  = 85
   Const ITEM_HEIGHT = 85
   Const ROLL_DISPLAY_HEIGHT = 240
   
   Text1      As _Font = _Font("OCRAEXT_14")
   Text2      As _Font = _Font("OCRAEXT_10")
   Text3      As _Font = _Font("OCRAEXT_14")
   Text4      As _Font = _Font("Arial_22")
   FPS        As _fps  = 60

   imgMain    As Any Ptr
   imgSlot    As Any Ptr
   imgSign    As Any Ptr
   imgRoll    As Any Ptr
   imgDisp    As Any Ptr
   imgHelp    As Any Ptr
   
   Coins      As Integer = 10
   Spent      As Integer
   Bet        As Integer
   LastBet    As Integer
   Bank       As Integer   
   msgMode    As Integer
   msgTimer   As Double
   HlpTimer   As Double
   jackpot    As Integer = 1000
   Winnings   As Integer
   
   Message    As String 
   MouseFunction  As Integer
   
   RollPos(MAX_ROLLS-1) As Integer
   RollSpd(MAX_ROLLS-1) As Single
   SlowRoll             As Integer
   
   flagRollDone    As Integer = 1
   flagStopTheRest As Integer = 0
   flagSpinClicked As Integer = 0
   
   Sounds As _Sound 
   
   Declare Constructor()
   Declare Destructor()
   Declare Sub DrawMe(dest As Any Ptr=0)
   Declare Sub DrawRoll(dest As Any Ptr=0, rollnum As Integer)
   Declare Sub DrawRolls(dest As Any Ptr=0)   
   Declare Sub DrawDisplay(dest As Any Ptr=0)
   Declare Sub DrawLiteBars(dest As Any Ptr=0)
   Declare Sub DrawHelp(dest As Any Ptr=0)
   Declare Sub ProcessRolls()
   Declare Sub StarRolls()
   Declare Sub SetMsgMode(mMode As Integer, delay As Integer)
   Declare Function CheckWinner() As Integer
   Declare Sub DrawTopLine(dest As Any Ptr)
   Declare Sub AddMessage(text As String)
   
End Type

Constructor _GameData()

   imgMain = ImageCreate(800,600)
   imgSlot = ImageCreate(800,600)
   imgSign = ImageCreate(445,72)
   imgRoll = ImageCreate(ROLL_WIDTH,ROLL_HEIGHT)
   imgDisp = ImageCreate(318,56)
   imgHelp = ImageCreate(300,500)
   
   BLoad ("images/slotroll.bmp",imgRoll) 
   BLoad ("images/slotmach.bmp",imgSlot)
   BLoad ("images/slotsign.bmp",imgSign)
   BLoad ("images/payouts.bmp" ,imgHelp)

End Constructor

Destructor _GameData()

   ImageDestroy(imgMain)
   ImageDestroy(imgSlot)
   ImageDestroy(imgSign)
   ImageDestroy(imgRoll)   
   ImageDestroy(imgDisp)
   
End Destructor

Sub _GameData.DrawMe(dest As Any Ptr=0)
Static As Double ltime
Static As Integer toggle = 0
   
   If Timer - ltime > 1 Then 
      toggle Xor= 1
      ltime = Timer
   EndIf
   
   Put imgMain,(0,0),imgSlot,Trans
   
   If toggle Then
      Put imgMain,(177,14),imgSign, PSet
   End If
   
   DrawDisplay(dest)
   Put dest,(0,0),imgMain,Trans
   
End Sub

Sub _GameData.DrawDisplay(dest As Any Ptr=0)
Dim As String text

   Line imgDisp,(0,0)-(318,56),0,BF
      
   Select Case msgMode
      
      Case 0:
         Text1.SetColor(&hFFFF00)
         Text1.DrawString(imgDisp,20,7,"Coins " & Format(Coins,"000000") )    '
         Text1.DrawString(imgDisp,240,7,"Bet " & Format(Bet,"0") )        
         text1.drawstring(imgDisp,70,30,"Press F12 for Help")
      
      Case 1:   
         'Text4.SetColor(&hFFFF)
         Text4.DrawString(imgDisp,100, 0, "You Won!")
         text = Winnings & " Coins!"
         Text3.DrawString(imgDisp,169-Len(text)/2*10, 30, text)
                  
   End Select
   
   Put dest,(240,512),imgDisp,PSet
   
   If Timer-msgTimer > 0 Then
      msgMode = 0
   EndIf   
   
End Sub

Sub _GameData.SetMsgMode(mMode As Integer, delay As Integer)
   
   msgMode  = mMode
   msgTimer = Timer + delay
   
End Sub

Sub _GameData.DrawRoll(dest As Any Ptr=0, rollnum As Integer) 
Dim As Integer top, lft, offset

   top = RollPos(rollnum)
   lft = 160+(rollnum*100)
      
   Put dest,(lft,160),imgRoll,(0,top)-Step(85,ROLL_DISPLAY_HEIGHT),PSet   
 
   If top+ROLL_DISPLAY_HEIGHT> ROLL_HEIGHT Then
      offset = ROLL_HEIGHT - top
      top = 0
      Put dest,(lft,160+offset),imgRoll,(0,top)-Step(85,ROLL_DISPLAY_HEIGHT-offset),PSet
   EndIf
   
End Sub

Sub _GameData.DrawRolls(dest As Any Ptr=0)

   For i As Integer = 0 To MAX_ROLLS-1
      DrawRoll(dest,i)
   Next
   
End Sub

Sub _GameData.ProcessRolls()
   
   If flagRollDone = 0 Then
      
      For i As Integer = 0 To MAX_ROLLS-1
         RollPos(i) -= RollSpd(i)
         If RollPos(i) < 0 Then RollPos(i)=850   
      Next
      
      If SlowRoll < 5 Then
         
         If RollSpd(SlowRoll) > 0 Then
            If (flagStopTheRest = 0) Then 
               RollSpd(SlowRoll) -= 1
            ElseIf (flagSpinClicked = 1) Then
               RollSpd(SlowRoll) = 0               
               flagSpinClicked   = 0
            EndIf            
            Exit Sub
         EndIf
   
         RollSpd(SlowRoll) =  0
   
         If (RollPos(SlowRoll) Mod ITEM_HEIGHT) Then
            RollPos(SlowRoll) += 1
         Else
            SoundEffect(Sounds.Clip(Stopped))
            GDPrint("Roll " & SlowRoll & " Pos " & RollPos(SlowRoll)/85)      
            If RollPos(SlowRoll) / 85 = 9 Then
               flagStopTheRest = 1
               AddMessage("Press SPIN to Stop")
            EndIf
            SlowRoll += 1
         EndIf
         
      Else
         
         flagStopTheRest = 0
         flagSpinClicked   = 0
         
          '  <========Proces Winner here
         Winnings = CheckWinner()
         
         If Winnings > 0 Then
            SetMsgMode(1,5)
            AddMessage("You Won " & Winnings & " Coins")
            SoundEffect(Sounds.Clip(Pay))
            If Winnings > 1000 Then
               fbs_Play_Sound (Sounds.Clip(Pay), 10)
            EndIf
            Coins += Winnings
         EndIf            
               
         flagRollDone = 1   
         Bet = 0        
         SlowRoll = 0
         
      End If
      
   End If
   
End Sub

Sub _GameData.StarRolls()

   If Bet > 0 AndAlso flagRollDone Then
   
      flagRollDone = 0
            
      SoundEffect(Sounds.Clip(SPIN))
      
      Randomize
      For i As Integer = 0 To MAX_ROLLS-1
         RollSpd(i) = 30 + (Rnd*4)
      Next
      
      Spent += Bet
      AddMessage("You've Spent " & Spent & " Coins")
      
   End If
   
End Sub

Sub _GameData.DrawLiteBars(dest As Any Ptr=0)
Static tmrFlash As Double
Static toggle As Integer
Dim newclr As UInteger
Dim As Integer lft
 
   If Timer-tmrFlash > .5 Then
      tmrFlash = Timer
      toggle Xor= 1
   EndIf
     
   For i As Integer = 0 To MAX_ROLLS-1
      newclr = &hFF00 
      Select Case LastBet
         Case 0
            newclr = 0
         Case 1
            If i > 2 Then
               newclr = 0
            EndIf
         Case 2
            If i > 3 Then
               newclr = 0
            EndIf
      End Select

      newclr = IIf(toggle, 0, newclr )

      lft = 160+(i*100)
      ThickBox (dest,lft,160,lft+85,160+ROLL_DISPLAY_HEIGHT, newclr)
      
      Line dest,(160,284)-(644,294),0,B
      
   Next
   
End Sub

Sub _GameData.DrawHelp(dest As Any Ptr=0)
   
   If Timer - HlpTimer < 8 Then
      Put dest,(500,40),imgHelp,Trans
   EndIf
   
End Sub

Function _GameData.CheckWinner() As Integer
Dim Combo As String = Space(5)
Dim As Integer Match
Dim test As String

   Winnings = 0
   Match = 0
   
   For i As Integer = 0 To MAX_ROLLS-1
      Mid(Combo,i+1,1) = Chr(64+RollPos(i)/85)
   Next

   combo = Left(combo, 2+Bet)

   GDPrint("Combo " & combo)   

   
   If InStr(1,Combo,"BBB") Then    '3 pi
      Winnings = 31
   End If
   
   If InStr(1,Combo,"BBBB") Then    '4pi
      Winnings = 314
   End If
   
   If InStr(1,Combo,"BBBBB") Then   ' 5pi
      Winnings = 3141
   End If
   
   If InStr(1,Combo,"DDD") Then     '3 infinity
      Winnings = 99
   End If
   
   If InStr(1,Combo,"DDDD") Then    '4 infinity
      Winnings = 999
   End If
   
   If InStr(1,Combo,"DDDDD") Then   '5 infinity
      Winnings = Jackpot
      Jackpot = 1000 'Reset Jackpot
   End If
   
   If InStr(1,Combo,"JJJ") Then     '3 e
      Winnings = 27
   EndIf
   
   If InStr(1,Combo,"JJJJ") Then    '4 e
      Winnings = 271
   End If
   
   If InStr(1,Combo,"JJJJJ") Then   '5 e
      Winnings = 2718
   End If
   
   If Winnings = 0 Then

      For i As Integer = 0 To 9
         test = Chr(65+i,65+i,65+i,65+i,65+i)
         If InStr(1,combo,test) Then
            match = 5
            Exit For
         EndIf
         test = Chr(65+i,65+i,65+i,65+i)
         If InStr(1,combo,test) Then
            match = 4
            Exit For
         EndIf
         test = Chr(65+i,65+i,65+i)
         If InStr(1,combo,test) Then
            match = 3
            Exit For
         EndIf
      Next

      If match Then
         Select Case Left(test,1)
            Case "A": Winnings = 9 * Bet * (Match-2) 
            Case "C": Winnings = 3 * Bet * (Match-2)
            Case "E": Winnings = 5 * Bet * (Match-2)
            Case "F": Winnings = 6 * Bet * (Match-2)
            Case "G": Winnings = 1 * Bet * (Match-2)
            Case "H": Winnings = 2 * Bet * (Match-2)
            Case "I": Winnings = 7 * Bet * (Match-2)            
         End Select            
      Else
         If InStr(1,Combo,"D") Then
            Winnings = 1 * Bet
         EndIf
      EndIf
               
   End If
      
   GDPrint("Winnings=" & Winnings)
   
   Return Winnings
   
End Function

Sub _GameData.DrawTopLine(dest As Any Ptr)
Static tmrMsgSpeed As Double
Dim dsp As String
Dim pDel As Integer

   If Len(message)=0 Then
      message = "JACKPOT " & Format(Jackpot,"#,###,###")
      Text4.DrawString(dest, 400-Len(message)/2*14, 95, message )
      message = ""
   Else
         
      pDel = InStr(1,Message,"|")
      If pDel = 0 Then pDel = Len(Message)
      
      dsp = Left(Message,pDel-1)
      
      'Text4.SetColor(&hFFFFFF)
      Text4.DrawString(dest, 400-Len(dsp)/2*14, 95, Left(Message,pDel-1) )
   
      If Timer - tmrMsgSpeed > 3 Then
         Message = Mid(Message,pDel+1)
         tmrMsgSpeed = Timer
      End If
   
   EndIf
   
End Sub

Sub _GameData.AddMessage(text As String)
   
   If Len(Message) = 0 Then Message = "|"
   Message = Message & text & "|"
   
End Sub
