#Include "inc/fbsound.bi"

#Define LoadWaveFile		fbs_Load_WAVFile
#Define LoadMP3File		fbs_Load_MP3File
#Define MuteSound			fbs_Set_SoundMuted

#Ifdef GAME_DEBUG_NO_SOUND
	#Define SoundEffect		
#else
	#Define SoundEffect	fbs_Play_Sound
#endif

Enum Effects
   Intro,
   Coin,
   Spin,
   Stopped,
   Pay,
   Casino,
   SoundCount
End Enum

Type _Sound
	Declare Destructor()
   Clip(255) As Integer
End Type

Destructor _Sound()

	For x As Integer=0 To 255
		DeAllocate Cast(Any Ptr,This.Clip(x)) 
	Next	
	
End Destructor

Sub SustainSound (sndSound As Integer)
Dim Volume As Single
Dim sndInfo As Integer

	fbs_Get_SoundVolume (sndSound, @Volume)

	If Volume <1 Then
		Volume += .01
		fbs_Set_SoundVolume (sndSound, Volume)
	EndIf

	fbs_get_SoundLoops(sndSound, @sndInfo)
	If sndInfo=0 Then
		fbs_Play_Sound (sndSound, 10)
	End If

End Sub

Sub FadeSound (sndSound As Integer)
	Dim Volume As Single
	Dim sndInfo As Integer

	fbs_Get_SoundVolume (sndSound, @Volume)

	Volume -= .01
	If Volume <0 Then Volume = 0

	fbs_Set_SoundVolume (sndSound, Volume)

End Sub

Sub InitSound()
Dim As FBSBOOLEAN ok

	ok=fbs_Init()

	If ok = FALSE Then
		GDPrint ("Sound Init Error:" & fbs_Get_PlugError())
	Else
		GDPrint ("Sound Initialized!")
	End If
   
End Sub

Function LoadSound (Filename As String) As Integer
Dim hSound As Integer
Dim hWave  As Integer

	GDPrint ("Loading->" & Filename)

	Select Case UCase(Right(Filename,3))
		Case "WAV"
			If LoadWaveFile(Filename,@hWave)=TRUE Then
				fbs_create_Sound (hWave,@hSound)
				GDPrint(Str(hSound))
			Else
				GDPrint ("Error loading " & Filename)
			End If
		Case "MP3"
			If LoadMP3File(Filename,@hWave)=TRUE Then
				fbs_create_Sound (hWave,@hSound)
			Else
				GDPrint("Error loading " & Filename)
			End If
		Case Else
			Print("Un-recognized Sound Format : " & Filename)
	End Select

   GDPrint("Sound Loaded #" & hSound)
   
	Return hSound

End Function

Sub LoadSounds(Sounds As _Sound)
   
   Sounds.Clip(Casino)   = LoadSound("sounds\casino.wav")   
   Sounds.Clip(Spin)     = LoadSound("sounds\slot_payoff.wav")
   Sounds.Clip(Coin)     = LoadSound("sounds\coin_drop.wav")
   Sounds.Clip(Stopped)  = LoadSound("sounds\spinstop.wav")
   Sounds.Clip(Pay)      = LoadSound("sounds\payout.wav")
   
End Sub

