  
Type star
   As Single  x,y
   As UInteger clr
End Type

Declare Sub _starfield_thread(param As Any Ptr)
   
Type _starfield
   
   Declare Constructor (numstars As Integer, scrwidth As Integer, scrheight As Integer)
   Declare Destructor()
   Declare Sub SetStars(direction As Single, speed As Single, clr As UInteger=&hFFFF00)
   Declare Sub DrawMe(dest As Any Ptr=0)
   
   As star Ptr Stars      
   
   As Integer  m_numstars, m_width, m_height
   As Single   m_speed, m_direction
   As UInteger m_clr
   
   As Any Ptr mtx
   As Integer thread_running, thread_exit
   
End Type

Constructor _starfield(numstars As Integer, scrwidth As Integer, scrheight As Integer)

   Stars = New star[numstars]
   m_numstars = numstars
   m_width = scrwidth
   m_height = scrheight
   m_speed = 0
   m_direction = 0
      
   For i As Integer = 0 To numstars-1
      Stars[i].x = Rnd * m_width
      Stars[i].y = Rnd * m_height
      Stars[i].clr = Rnd * &hFFFFFF
   Next
   
   mtx = MutexCreate()
   
   ThreadCreate (@_starfield_thread, @This)
   
End Constructor

Destructor _starfield()

   this.thread_exit = 1
   
   While (this.thread_running)
      Sleep(1000)
   Wend
   
   Delete[] Stars

   MutexDestroy(mtx)

End Destructor

Sub _starfield.SetStars(direction As Single, speed As Single, clr As UInteger=&hFFFF00)
   
   m_speed = speed
   m_direction = direction
   m_clr = clr
   
End Sub

Sub _starfield.DrawMe(dest As Any Ptr=0)
   
   MutexLock(mtx)
   For i As Integer = 0 To m_numstars-1
      Line (Stars[i].x, Stars[i].y)-Step(2,2),Stars[i].clr,BF
   Next
   MutexUnLock(mtx)
   
End Sub

Sub _starfield_thread(param As Any Ptr)
Dim sf As _starfield Ptr = param

   sf->thread_exit = 0
   sf->thread_running = 1
   
   Do   
      MutexLock(sf->mtx)
      For i As Integer = 0 To sf->m_numstars-1
         
         sf->Stars[i].x += Cos(sf->m_direction)*sf->m_speed
         sf->Stars[i].y += Sin(sf->m_direction)*sf->m_speed
         
         If sf->Stars[i].x > sf->m_width Then sf->Stars[i].x -= sf->m_width
         If sf->Stars[i].x < 0 Then sf->Stars[i].x += sf->m_width 
         If sf->Stars[i].y > sf->m_height Then sf->Stars[i].y -= sf->m_height
         If sf->Stars[i].y < 0 Then sf->Stars[i].y += sf->m_height 
         
      Next      
      MutexUnLock(SF->mtx)
      
      Sleep(33)
      
   Loop Until sf->thread_exit
   
   sf->thread_running = 0
    

End Sub
