#Ifndef pi
   Const pi = Atn(1)*4
#EndIf

Const pi_180 = pi / 180

'Rotozoom for 32-bit FB.Image by Dr_D(Dave Stanley) and yetifoot(Simon Nash)
'
Function _RotoZoom(  dst As FB.IMAGE Ptr, _
                     src As Const FB.IMAGE Ptr, _
                     positx As Integer, _
                     posity As Integer, _
                     angle As Integer, _
                     zoomx As Single, _
                     zoomy As Single, _
                     transcol As UInteger, _
                     offsetx As Integer, _
                     offsety As Integer) As Integer 

   Static As Integer mx, my, col, nx, ny
   Static As Single nxtc, nxts, nytc, nyts
   Static As Single tcdzx, tcdzy, tsdzx, tsdzy
   Static As Integer sw2, sh2, dw, dh
   Static As Single tc, ts, _mx, _my
   Static As UInteger Ptr dstptr, srcptr, odstptr
   Static As Integer xput, yput, startx, endx, starty, endy
   Static As Integer x(3), y(3), xa, xb, ya, yb, lx, ly
   Static As UByte Ptr srcbyteptr, dstbyteptr
   Static As Integer dstpitch, srcpitch, srcbpp, dstbpp, srcwidth, srcheight

   If zoomx = 0 Then Return 1
   If zoomy = 0 Then zoomy = zoomx
   If src   = 0 Then Return 1

   If dst = 0 Then
      dstptr = ScreenPtr
      odstptr = dstptr
      ScreenInfo dw,dh,,,dstpitch
   Else
      dstptr = Cast( UInteger Ptr, dst + 1 )
      odstptr = Cast( UInteger Ptr, dst + 1 )
      dw = dst->Width
      dh = dst->height
      dstbpp = dst->bpp
      dstpitch = dst->pitch
   End If

   srcptr     = Cast( UInteger Ptr, src + 1 )
   srcbyteptr = Cast( UByte Ptr, srcptr )
   dstbyteptr = Cast( UByte Ptr, dstptr )

   sw2 = src->Width\2
   sh2 = src->height\2
   srcbpp = src->bpp
   srcpitch = src->pitch
   srcwidth = src->Width
   srcheight = src->height

   tc = Cos( angle * pi_180 )
   ts = Sin( angle * pi_180 )
   tcdzx = tc/zoomx
   tcdzy = tc/zoomy
   tsdzx = ts/zoomx
   tsdzy = ts/zoomy

   xa = sw2 * tc * zoomx + sh2  * ts * zoomx
   ya = sh2 * tc * zoomy - sw2  * ts * zoomy

   xb = sh2 * ts * zoomx - sw2  * tc * zoomx
   yb = sw2 * ts * zoomy + sh2  * tc * zoomy

   Dim As Integer centerx = -(offsetx*(tc*zoomx) + offsety*(ts*zoomx)) + offsetx
   Dim As Integer centery = -(offsety*(tc*zoomy) - offsetx*(ts*zoomy)) + offsety

   x(0) = sw2-xa
   x(1) = sw2+xa
   x(2) = sw2-xb
   x(3) = sw2+xb
   y(0) = sh2-ya
   y(1) = sh2+ya
   y(2) = sh2-yb
   y(3) = sh2+yb

   For i As Integer = 0 To 3
      For j As Integer = i To 3
         If x(i)>=x(j) Then
            Swap x(i), x(j)
         End If
      Next
   Next
   
   startx = x(0)
   endx = x(3)

   For i As Integer = 0 To 3
      For j As Integer = i To 3
         If y(i)>=y(j) Then
            Swap y(i), y(j)
         End If
      Next
   Next
   
   starty = y(0)
   endy = y(3)

   positx-=sw2
   posity-=sh2
   positx+=centerx
   posity+=centery
   If posity+starty<0 Then starty = -posity
   If positx+startx<0 Then startx = -positx
   If posity+endy<0   Then endy = -posity
   If positx+endx<0   Then endx = -positx

   If positx+startx>(dw-1) Then startx = (dw-1)-positx
   If posity+starty>(dh-1) Then starty = (dh-1)-posity
   If positx+endx>(dw-1)   Then endx = (dw-1)-positx
   If posity+endy>(dh-1)   Then endy = (dh-1)-posity
   If startx = endx Or starty = endy Then Return 2

   xput = (startx + positx) * 4
   yput = starty + posity
   ny = starty - sh2
   nx = startx - sw2
   nxtc = (nx * tcdzx)
   nxts = (nx * tsdzx)
   nytc = (ny * tcdzy)
   nyts = (ny * tsdzy)
   dstptr += dstpitch * yput \ 4

   Dim As Integer y_draw_len = (endy - starty) + 1
   Dim As Integer x_draw_len = (endx - startx) + 1

   Asm
      mov edx, dword Ptr [y_draw_len]

      test edx, edx ' 0?
      jz y_end      ' nothing to do here

      fld dword Ptr[tcdzy]
      fld dword Ptr[tsdzy]
      fld dword Ptr [tcdzx]
      fld dword Ptr [tsdzx]

      y_inner:

      fld dword Ptr[nxtc]     'st(0) = nxtc, st(1) = tsdzx, st(2) = tcdzx, st(3) = tsdzy, st(4) = tcdzy
      fsub dword Ptr[nyts]    'nxtc-nyts
      fiadd dword Ptr[sw2]    'nxtc-nyts+sw2

      fld dword Ptr[nxts]     'st(0) = nxts, st(1) = tsdzx, st(2) = tcdzx, st(3) = tsdzy, st(4) = tcdzy
      fadd dword Ptr[nytc]    'nytc+nxts
      fiadd dword Ptr[sh2]    'nxts+nytc+sh2
      'fpu stack returns to: st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy

      mov ebx, [xput]
      Add ebx, [dstptr]

      mov ecx, dword Ptr [x_draw_len]

      test ecx, ecx ' 0?
      jz x_end      ' nothing to do here

      x_inner:

      fist dword Ptr [my] ' my = _my

      fld st(1)           ' mx = _mx
      fistp dword Ptr [mx]

      mov esi, dword Ptr [mx]         ' esi = mx
      mov edi, dword Ptr [my]         ' edi = my

      ' bounds checking
      test esi, esi       'mx<0?
      js no_draw
      'mov esi, 0

      test edi, edi
      'mov edi, 0
      js no_draw          'my<0?

      cmp esi, dword Ptr [srcwidth]   ' mx >= width?
      jge no_draw
      cmp edi, dword Ptr [srcheight]  ' my >= height?
      jge no_draw

      ' calculate position in src buffer
      mov eax, dword Ptr [srcbyteptr] ' eax = srcbyteptr
      imul edi, dword Ptr [srcpitch]  ' edi = my * srcpitch
      Add eax, edi
      Shl esi, 2
      ' eax becomes src pixel color
      mov eax, dword Ptr [eax+esi]
      cmp eax, [transcol]
      je no_draw

      ' draw pixel
      mov dword Ptr [ebx], eax
      no_draw:

      fld st(3)
      faddp st(2), st(0) ' _mx += tcdzx
      fadd st(0), st(2) ' _my += tsdzx

      ' increment the output pointer
      Add ebx, 4

      ' increment the x loop
      dec ecx
      jnz x_inner

      x_end:

      fstp dword Ptr [_my]
      fstp dword Ptr [_mx]

      'st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy
      'nytc += tcdzy
      fld dword Ptr[nytc]
      fadd st(0), st(4)
      fstp dword Ptr[nytc]

      'st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy
      'nyts+=tsdzy
      fld dword Ptr[nyts]
      fadd st(0), st(3)
      fstp dword Ptr[nyts]

      'dstptr += dst->pitch
      mov eax, dword Ptr [dstpitch]
      Add dword Ptr [dstptr], eax

      dec edx
      jnz y_inner

      y_end:

      finit
   End Asm

   Return 0
   
End Function

Function LoadBmp(fname As String) As Any Ptr
 Dim As Integer hf = FreeFile
 Dim As Integer dx, dy
 Dim As Any Ptr Tmp
    
    Open fname For Binary As #hf    
        Get #hf, 19, dx
        Get #hf, 23, dy        
    Close #hf
    
    Tmp = ImageCreate(dx,dy)
    
    BLoad fname, Tmp
    
    Return Tmp
       
End Function

Function KeyPress(Key As Integer) As Integer
Static LastKey(255) As Integer

    If MultiKey(Key) = -1 Then
        If Key = LastKey(Key) Then
            Return (0)
        Else
            LastKey(Key)=Key
            Return (-1)
        EndIf
    Else
        LastKey(Key)=0
        Return (0)
    End If

End Function

Sub ThickBox(dest As Any Ptr, x1 As Integer,y1 As Integer, x2 As Integer, y2 As Integer, clr As UInteger)
   
   For i As Integer = -3 To 3 
      Line dest,(x1+i,y1+i)-(x2-i,y2-i),clr,B
   Next
   
End Sub

